package com.casic.dcms.mvp.model.impl;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.listener.OnActionResultListener;
import com.casic.dcms.mvp.model.IPackageHandleModel;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class PackageHandleModelImpl implements IPackageHandleModel {

    private final OnActionResultListener actionResultListener;

    public PackageHandleModelImpl(OnActionResultListener listener) {
        this.actionResultListener = listener;
    }

    /**
     * {@link IPackageHandleModel}
     */
    @Override
    public Subscription sendPackageHandleRequest(String id, String punishType, String punishRemarks, String punishTime,
                                                 String punishImage) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getHandlePackageResult(id, punishType,
                punishRemarks, punishTime, punishImage);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    actionResultListener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    actionResultListener.onSuccess(resultBean);
                }
            }
        });
    }
}
